onEvent('recipes', e => {
  e.remove({ output: 'pneumaticcraft:ingot_iron_compressed' })
  e.remove({ output: 'pneumaticcraft:compressed_iron_block' })
  e.remove({ output: 'pneumaticcraft:assembly_platform' })
  e.remove({ output: 'pneumaticcraft:assembly_io_unit_import' })
  e.remove({ output: 'pneumaticcraft:assembly_io_unit_export' })
  e.remove({ output: 'pneumaticcraft:assembly_drill' })
  e.remove({ output: 'pneumaticcraft:assembly_laser' })
  e.remove({ output: 'pneumaticcraft:assembly_controller' })
  e.remove({ output: 'pneumaticcraft:assembly_program_drill_laser' })
  e.remove({ output: 'pneumaticcraft:assembly_program_drill_laser' })
  e.remove({ output: 'pneumaticcraft:assembly_program_laser' })
  e.remove({ output: 'pneumaticcraft:pressure_tube' })
  e.remove({ output: 'pneumaticcraft:air_compressor' })
  e.remove({ output: 'pneumaticcraft:pneumatic_cylinder' })
  e.remove({ output: 'pneumaticcraft:charging_station' })
  e.remove({ output: 'pneumaticcraft:amadron_tablet' })
  e.remove({ output: 'pneumaticcraft:uv_light_box' })
  e.remove({ output: 'pneumaticcraft:etching_tank' })
  e.remove({ output: 'pneumaticcraft:vortex_tube' })
  e.remove({ output: 'pneumaticcraft:refinery' })
  e.remove({ output: 'pneumaticcraft:refinery_output' })
  e.remove({ output: 'pneumaticcraft:thermopneumatic_processing_plant' })
  e.remove({ output: 'pneumaticcraft:pressure_chamber_glass' })
  e.remove({ output: 'pneumaticcraft:pressure_chamber_wall' })
  e.remove({ output: 'pneumaticcraft:pressure_chamber_valve' })
  e.remove({ output: 'pneumaticcraft:pressure_chamber_interface' })
  e.remove({ output: 'pneumaticcraft:advanced_pcb' })
  e.remove({ output: 'pneumaticcraft:advanced_air_compressor' })
  e.remove({ output: 'pneumaticcraft:advanced_liquid_compressor' })
  e.remove({ output: 'pneumaticcraft:speed_upgrade' })
  e.remove({ output: 'pneumaticcraft:pressurized_spawner' })
  e.remove({ output: 'pneumaticcraft:pneumatic_dynamo' })
  e.remove({ output: 'pneumaticcraft:flux_compressor' })
  e.remove({ output: 'mekanism:energy_tablet' })
  e.remove({ output: 'pneumaticcraft:advanced_pressure_tube' })
  e.remove({ output: 'minecraft:crafting_table' })
  
-
  
  e.shaped('8x pneumaticcraft:pressure_tube', [
    ' 1 ',
    '232',
    ' 1 '
  ], {
    1: 'pneumaticcraft:ingot_iron_compressed', 2: 'pneumaticcraft:compressed_iron_block', 3: 'botania:mana_spreader'
  })

  e.shaped('pneumaticcraft:pneumatic_cylinder', [
    ' 2 ',
    ' 2 ',
    ' 1 '
  ], {
    1: 'pneumaticcraft:compressed_iron_block', 2: 'minecraft:piston'
  })

  e.shaped('pneumaticcraft:air_compressor', [
    '111',
    '234',
    '212'
  ], {
    1: 'pneumaticcraft:ingot_iron_compressed', 2: 'pneumaticcraft:compressed_iron_block', 3: 'minecraft:furnace', 4: 'botania:exoflame'
  })

  e.shaped('pneumaticcraft:assembly_platform', [
    '   ',
    ' 3 ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'botania:hopperhock'
  })

  e.shaped('pneumaticcraft:assembly_laser', [
    '334',
    '3  ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pneumatic_cylinder', 4: 'botania:elementium_ingot'
  })

  e.shaped('pneumaticcraft:assembly_io_unit_export', [
    '334',
    '3  ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pneumatic_cylinder', 4: 'botania:pixie_dust'
  })

  e.shaped('pneumaticcraft:assembly_io_unit_import', [
    '334',
    '3  ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pneumatic_cylinder', 4: 'botania:dragonstone'
  })

  e.shaped('pneumaticcraft:assembly_drill', [
    '334',
    '3  ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pneumatic_cylinder', 4: 'botania:mana_diamond'
  })

  e.shaped('pneumaticcraft:assembly_controller', [
    ' 4 ',
    ' 3 ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pneumatic_cylinder', 4: 'pneumaticcraft:pressure_gauge'
  })

  e.shaped('pneumaticcraft:charging_station', [
    '   ',
    '34 ',
    '212'
  ], {
    2: 'pneumaticcraft:ingot_iron_compressed', 1: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:pressure_tube', 4: 'pneumaticcraft:pressure_gauge'
  })

  e.shaped('pneumaticcraft:amadron_tablet', [
    '141',
    '535',
    '121'
  ], {
    1: 'pneumaticcraft:ingot_iron_compressed', 2: 'pneumaticcraft:air_canister', 3: 'minecraft:glass_pane', 4: 'pneumaticcraft:seismic_sensor', 5: 'pneumaticcraft:logistics_module'
  })

  e.shaped('kubejs:utransistorparts', [
    '  7',
    '123',
    '456'
  ], {
    1: 'minecraft:redstone', 2: 'minecraft:paper', 3: 'botania:terrasteel_nugget', 4: '#forge:ingots/copper', 5: '#forge:ingots/lead', 6: '#forge:ingots/tin', 7: '#forge:slimeballs'
  })

  e.shaped('kubejs:ucapacitorparts', [
    '  7',
    '123',
    '456'
  ], {
    1: 'minecraft:redstone', 2: 'minecraft:paper', 3: 'botania:terrasteel_nugget', 4: '#forge:ingots/copper', 5: '#forge:ingots/copper', 6: '#forge:ingots/silver', 7: '#forge:slimeballs'
  })

  e.shaped('pneumaticcraft:uv_light_box', [
    '311',
    '425',
    '111'
  ], {
    1: 'pneumaticcraft:ingot_iron_compressed', 2: 'pneumaticcraft:empty_pcb', 3: 'pneumaticcraft:pressure_tube', 4: 'pneumaticcraft:capacitor', 5: 'pneumaticcraft:transistor'
  })

  e.shaped('pneumaticcraft:etching_tank', [
    '161',
    '435',
    '121'
  ], {
    1: 'pneumaticcraft:ingot_iron_compressed', 2: 'pneumaticcraft:compressed_iron_block', 3: '#forge:glass', 4: 'pneumaticcraft:capacitor', 5: 'pneumaticcraft:transistor', 6: 'pneumaticcraft:small_tank'
  })

  e.shaped('pneumaticcraft:vortex_tube', [
    '131',
    '4 4',
    '121'
  ], {
    1: 'pneumaticcraft:compressed_iron_block', 2: 'pneumaticcraft:capacitor', 3: 'pneumaticcraft:transistor', 4: 'pneumaticcraft:pressure_tube'
  })

  e.shaped('pneumaticcraft:refinery', [
    '131',
    '141',
    '121'
  ], {
    1: 'kubejs:compressedironplate', 2: 'pneumaticcraft:compressed_iron_block', 3: 'pneumaticcraft:printed_circuit_board', 4: 'pneumaticcraft:small_tank'
  })

  e.shaped('pneumaticcraft:refinery_output', [
    '141',
    '141',
    '131'
  ], {
    1: 'kubejs:compressedironplate', 3: 'pneumaticcraft:printed_circuit_board', 4: '#forge:glass'
  })

  e.shaped('pneumaticcraft:thermopneumatic_processing_plant', [
    '131',
    '242',
    '252'
  ], {
    1: 'pneumaticcraft:small_tank', 2: 'kubejs:compressedironplate', 3: 'pneumaticcraft:pressure_tube', 4: 'pneumaticcraft:printed_circuit_board', 5: 'pneumaticcraft:compressed_iron_block'
  })

  e.shaped('pneumaticcraft:fluid_mixer', [
    '131',
    '212',
    '252'
  ], {
    1: 'pneumaticcraft:small_tank', 2: 'kubejs:compressedironplate', 3: 'pneumaticcraft:pressure_tube', 5: 'pneumaticcraft:printed_circuit_board'
  })

  e.shaped('2x pneumaticcraft:advanced_pcb', [
    '121',
    '232',
    '121'
  ], {
    1: 'pneumaticcraft:printed_circuit_board', 2: 'pneumaticcraft:plastic', 3: 'minecraft:redstone_block'
  })

  e.shaped('2x kubejs:chamberbase', [
    '121',
    '131',
    '121'
  ], {
    1: 'kubejs:compressedironplate', 2: 'pneumaticcraft:plastic', 3: 'minecraft:obsidian'
  })

  e.shaped('pneumaticcraft:pressure_chamber_interface', [
    ' 1 ',
    ' 2 ',
    ' 1 '
  ], {
    1: 'pneumaticcraft:pressure_chamber_wall', 2: 'pneumaticcraft:advanced_pcb'
  })

  e.shaped('pneumaticcraft:pressure_chamber_valve', [
    ' 1 ',
    ' 2 ',
    ' 1 '
  ], {
    1: 'pneumaticcraft:pressure_chamber_wall', 2: 'pneumaticcraft:pressure_tube'
  })

  e.shaped(Item.of('pneumaticcraft:spawner_core', '{"pneumaticcraft:SpawnerCoreStats":{"minecraft:zombie":100}}'), [
    '222',
    '113',
    '114'
  ], {
    1: 'kubejs:compressedironplate', 2: 'kubejs:reinforcedpcb', 3: '#pneumaticcraft:plastic_bricks', 4: 'minecraft:rotten_flesh'
  })

  e.shaped(Item.of('pneumaticcraft:spawner_core', '{"pneumaticcraft:SpawnerCoreStats":{"minecraft:skeleton":100}}'), [
    '222',
    '113',
    '114'
  ], {
    1: 'kubejs:compressedironplate', 2: 'kubejs:reinforcedpcb', 3: '#pneumaticcraft:plastic_bricks', 4: 'minecraft:bone'
  })

  e.shaped(Item.of('pneumaticcraft:spawner_core', '{"pneumaticcraft:SpawnerCoreStats":{"minecraft:enderman":100}}'), [
    '222',
    '113',
    '114'
  ], {
    1: 'kubejs:compressedironplate', 2: 'kubejs:reinforcedpcb', 3: '#pneumaticcraft:plastic_bricks', 4: 'minecraft:ender_pearl'
  })

  e.shaped(Item.of('pneumaticcraft:spawner_core', '{"pneumaticcraft:SpawnerCoreStats":{"minecraft:creeper":100}}'), [
    '222',
    '113',
    '114'
  ], {
    1: 'kubejs:compressedironplate', 2: 'kubejs:reinforcedpcb', 3: '#pneumaticcraft:plastic_bricks', 4: 'minecraft:gunpowder'
  })

  e.shaped(Item.of('pneumaticcraft:spawner_core', '{"pneumaticcraft:SpawnerCoreStats":{"minecraft:blaze":100}}'), [
    '222',
    '113',
    '114'
  ], {
    1: 'kubejs:compressedironplate', 2: 'kubejs:reinforcedpcb', 3: '#pneumaticcraft:plastic_bricks', 4: 'minecraft:blaze_rod'
  })

  e.shaped('pneumaticcraft:speed_upgrade', [
    '313',
    '121',
    '313'
  ], {
    1: 'pneumaticcraft:glycerol', 2: 'pneumaticcraft:large_tank', 3: 'pneumaticcraft:upgrade_matrix'
  })

  e.shaped('kubejs:etchingmixture', [
    '   ',
    '456',
    '123'
  ], {
    1: 'minecraft:bowl', 2: 'minecraft:poisonous_potato', 3: 'exnihilosequentia:bucket_witchwater', 4: 'minecraft:spider_eye', 5: 'minecraft:redstone', 6: 'minecraft:ink_sac'
  })

})